// For version_upload.hta


var g_oVersionUpload;
var g_oCommonUse = new CommonUse();

function OnloadInit()
{
	g_oVersionUpload = new CVersionUpload();
	g_oVersionUpload.Init1();
}

function CVersionUpload()
{
	var _arrArguments				= window.dialogArguments[0];
	var _oUsbActionCfg				= new CUsbActionCfg();
	var _oLanCfg					= new CLanCfg();

	var RMX_VERSIONS_PATH			= "rmx_versions/";
	
	var _oDownloadPathFile			= document.getElementById("_dstid_DownloadPathFile");
	var _oShowDownloadPathTxtBox	= document.getElementById("_dstid_ShowDownloadPathTxtBox");
	var _oBrowseBtn					= document.getElementById("_dstid_BrowseBtn");
	var _oAddBtn					= document.getElementById("_dstid_AddBtn");
	
	var _oSelectedVersionLstBox		= document.getElementById("_dstid_SelectedVersionLstBox");
	var _oSelectedVersionNumberTd	= document.getElementById("_dstid_SelectedVersionNumberTd");

	var _oOperationInfoDiv          = document.getElementById("_dstid_OperationInfoDiv");

	var _oCancelBtn					= document.getElementById("_dstid_CancelBtn");
	var _oOkBtn						= document.getElementById("_dstid_OkBtn");

	this.Init1 = function () {
	    document.title = "Collaboration Server Software Version Alignment Application";

	    _oOperationInfoDiv.innerText = "Click OK to configure the USB memory stick for the operation.\nTo initiate the operation insert the USB memory stick into the system and reboot.";

	    _InitEvent();

	    _UpdateVersionList();
	}
	
	function _InitEvent()
	{
		_oShowDownloadPathTxtBox.readOnly = true;
		_oShowDownloadPathTxtBox.style.backgroundColor = "#FFFFFF";
		_oShowDownloadPathTxtBox.style.color = "#908D80";
		_oShowDownloadPathTxtBox.disabled = true;
		_oDownloadPathFile.onchange = _OnchangeDownloadPathFile;
		document.onmousemove = _OnmousemoveDocument;
		_oAddBtn.onclick = _OnclickAddBtn;
		
		_oSelectedVersionLstBox.onchange = _OnchangeSelectedVersionLstBox;
		
		_oCancelBtn.onclick = _OnclickCancelBtn;
		_oOkBtn.onclick = _OnclickOkBtn;
	}
	
	this.EnableDownloadBtns = function ()
	{
		_oDownloadPathFile.readOnly = false;
		_oBrowseBtn.disabled = false;
		_oAddBtn.disabled = false;
	}
	
	this.DisableDownloadBtns = function ()
	{
		_oDownloadPathFile.readOnly = true;
		_oBrowseBtn.disabled = true;
		_oAddBtn.disabled = true;
	}
	
	function _OnmousemoveDocument()
	{
		if (false == _oBrowseBtn.disabled)
		{
			if (
				   event.x - 1 >= g_oCommonUse.GetAbsoluteLeft(_oBrowseBtn) 
				&& event.y - 1 >= g_oCommonUse.GetAbsoluteTop(_oBrowseBtn)
				&& event.x + 1 <= g_oCommonUse.GetAbsoluteLeft(_oBrowseBtn) + _oBrowseBtn.offsetWidth
				&& event.y + 1 <= g_oCommonUse.GetAbsoluteTop(_oBrowseBtn) + _oBrowseBtn.offsetHeight
			)
			{
				/*
				*	Move the upload control to the position of Browse button
				*/
				_oDownloadPathFile.style.top = event.y - _oDownloadPathFile.offsetHeight / 2;
				_oDownloadPathFile.style.left = event.x - _oDownloadPathFile.offsetWidth / 2;
				_oDownloadPathFile.readOnly = false;
			}
			else
			{
				_oDownloadPathFile.style.top = 0;
				_oDownloadPathFile.style.left = 0;
				_oDownloadPathFile.readOnly = true;
			}
		}
	}
	
	/*****************************************************************************************************
	* Name			: OnchangeDownloadPathFile
	* Function		: Display the path of the file upload.
	*****************************************************************************************************/
	function _OnchangeDownloadPathFile()
	{
		_oShowDownloadPathTxtBox.value = _oDownloadPathFile.value;
	}
	
	function _OnclickAddBtn()
	{
		if ("" == _oShowDownloadPathTxtBox.value)
		{
			alert("You must select a file to add.");
			return false;
		}

        var iIdx = _oShowDownloadPathTxtBox.value.lastIndexOf(".");
        if (-1 == iIdx) {
            alert("Error file format");
            return;
        }
        else {
            var szExName = _oShowDownloadPathTxtBox.value.substr(iIdx + 1);
            if ("bin" != szExName) {
                alert("Error file format");
                return;
            }
        }

		var fso = new ActiveXObject("Scripting.FileSystemObject");
		if (!fso.FolderExists(RMX_VERSIONS_PATH))
		{
			fso.CreateFolder(RMX_VERSIONS_PATH);
		}
		fso.CopyFile(_oShowDownloadPathTxtBox.value, RMX_VERSIONS_PATH);

		_UpdateVersionList();

		alert("Add version successfully");
	}
	
	function _UpdateVersionList()
	{
		var fso = new ActiveXObject("Scripting.FileSystemObject");
		
		if (!fso.FolderExists(RMX_VERSIONS_PATH))
		{
			return;
		}
		
		var folder = fso.GetFolder(RMX_VERSIONS_PATH);
		var fenum = new Enumerator(folder.Files);
		var szCurSelectedVersion = _oSelectedVersionLstBox.value;
		var szExtension = ".bin";
		_oSelectedVersionLstBox.options.length = 0;
		for (var i = 0 ; !fenum.atEnd(); fenum.moveNext(),i++)
		{
			var szCurExtension = fenum.item().Name.substring(fenum.item().Name.length - szExtension.length);
			if (szExtension != szCurExtension)
			{
				continue; // file extension error
			}
			var szFileBaseName = fenum.item().Name.substring(0, fenum.item().Name.length - szExtension.length);
			_oSelectedVersionLstBox.options[_oSelectedVersionLstBox.options.length] = new Option(szFileBaseName, szFileBaseName);
			if (szCurSelectedVersion == szFileBaseName)
			{
				_oSelectedVersionLstBox.selectedIndex = _oSelectedVersionLstBox.options.length - 1;
			}
		}
		if (szCurSelectedVersion != _oSelectedVersionLstBox.value)
		{
			_OnchangeSelectedVersionLstBox();
		}
	}
	
	function _OnchangeSelectedVersionLstBox()
	{
		var szFileName = RMX_VERSIONS_PATH + _oSelectedVersionLstBox.value + ".bin"
		var fso = new ActiveXObject("Scripting.FileSystemObject");
		if (!fso.FileExists(szFileName))
		{
			return "";
		}
		
		var objShell = new ActiveXObject( "WScript.Shell" );
		var szApp = objShell.CurrentDirectory + "/Utils/GetVersion.exe " + objShell.CurrentDirectory + "/" + szFileName;
		objShell.Run(szApp, 0, true);
		objShell = null;
		
		var szVersionFile = "__version.txt";
		if (!fso.FileExists(szVersionFile))
		{
			return "";
		}
		_oSelectedVersionNumberTd.innerText = g_oCommonUse.ReadFile(szVersionFile);
		fso.DeleteFile(szVersionFile);
	}
	
	function _OnclickCancelBtn()
	{
		window.returnValue = undefined;
		window.close();
		return false;
	}
	
	function _OnclickOkBtn()
	{
		var szPrompt;
		
		if ("" == _oSelectedVersionLstBox.value)
		{
			szPrompt = "Invalid Selected Version";
			alert(szPrompt);
			return false;
		}
		
		// Usb action configuration
		var arrUsbActionCfg = new Array();
		arrUsbActionCfg[_oUsbActionCfg.GetUsbUpgradeDowngradeStr()] = "YES";
		arrUsbActionCfg[_oUsbActionCfg.GetUserSelectedVersionStr()] = _oSelectedVersionLstBox.value + ".bin";
		_oUsbActionCfg.SaveCfg(arrUsbActionCfg);
		_oLanCfg.RemoveCfgFile();
		alert("Configuration file updated successfully");
		
		window.returnValue = undefined;
		window.close();
		return false;
	}
}


