// For RPCS800s_lan_config.hta


var g_oGesherLanConfig;
var g_oCommonUse = new CommonUse();
function OnloadInit()
{
	g_oGesherLanConfig = new CGesherLanConfig();
	g_oGesherLanConfig.Init1();
}

function CGesherLanConfig()
{
	var _oPromptInfoTbl				= document.getElementById("_dstid_PromptInfoTbl");
	var _oPromptInfoSpan			= document.getElementById("_dstid_PromptInfoSpan");
	var _oLanPromptInfoHr			= document.getElementById("_dstid_PromptInfoHr");
	var _oLanCfgTr					= document.getElementById("_dstid_LanCfgTr");
	var _oLanCfgSpan				= document.getElementById("_dstid_LanCfgSpan");

	var _oLanCfgInfoTr              = document.getElementById("_dstid_LanCfgInfoTr");
	var _oLanCfgInfoDiv             = document.getElementById("_dstid_LanCfgInfoDiv");
	var _oLanConfigChkBox			= document.getElementById("_dstid_LanConfigChkBox");
	var _oLanConfigCheckTd			= document.getElementById("_dstid_LanConfigCheckTd");
	var _oLanConfigTbl				= document.getElementById("_dstid_LanConfigTbl");
	var _oControlUnitIPV4TextBox	= document.getElementById("idControlUnitIPV4TextBox");
	var _oSubnetMaskTextBox			= document.getElementById("idSubnetMaskTextBox");
	var _oDefaultRouterIPV4TextBox  = document.getElementById("idDefaultRouterIPV4TextBox");

	var _oLanCfgInfoBottomTr        = document.getElementById("_dstid_LanCfgInfoBottomTr");
	var _oLanCfgInfoBottomDiv       = document.getElementById("_dstid_LanCfgInfoBottomDiv");

	var _oCancelBtn					= document.getElementById("_dstid_CancelBtn");
	var _oOkBtn						= document.getElementById("_dstid_OkBtn");
	var _arrArguments				= window.dialogArguments[0];
	
	var _oUsbActionCfg				= new CUsbActionCfg();
	var _oLanCfg					= new CLanCfg();

	this.Init1 = function () {
	    if ("LAN_CONFIG" == _arrArguments["application"]) {
	        document.title = "LAN Configuration Utility";
	        _oLanConfigTbl.style.marginTop = "20px";
	        _oLanConfigCheckTd.style.width = "0px";

	        _oLanCfgInfoBottomTr.style.display = "";
	        _oLanCfgInfoBottomDiv.innerText = "Click OK to configure the USB memory stick for the operation.\nTo initiate the operation insert the USB memory stick into the system and reboot.";
	    }
	    else if ("RESTORE_TO_FACTORY_DEFAULTS" == _arrArguments["application"]) {
	        document.title = "Restore to Factory Defaults";
	        _oLanCfgInfoTr.style.display = "";
	        _oLanCfgInfoDiv.innerText = "Selecting the LAN Configuration option and defining the LAN parameters will automatically reconfigure the Management Network Service.";
	        _oPromptInfoTbl.style.display = "";
	        _oPromptInfoSpan.innerText = "The current system configuration is about to be erased. Do you want to continue?\nClick OK to configure the USB memory stick for the operation.\nTo initiate the operation insert the USB memory stick into the system and reboot.";
	        _oLanPromptInfoHr.style.display = "";
	        _oLanCfgTr.style.display = "";
	    }

	    var arrLanCfg = new Array();
	    _oLanCfg.LoadCfg(arrLanCfg);

	    if (arrLanCfg[_oLanCfg.GetManagmentIpAddrStr()]) {
	        _oControlUnitIPV4TextBox.value = arrLanCfg[_oLanCfg.GetManagmentIpAddrStr()];
	    }

	    if (arrLanCfg[_oLanCfg.GetManagmentSubnetmaskStr()]) {
	        _oSubnetMaskTextBox.value = arrLanCfg[_oLanCfg.GetManagmentSubnetmaskStr()];
	    }

	    if (arrLanCfg[_oLanCfg.GetManagmentDefgatewayStr()]) {
	        _oDefaultRouterIPV4TextBox.value = arrLanCfg[_oLanCfg.GetManagmentDefgatewayStr()];
	    }

	    _InitEvent();

	    if ("RESTORE_TO_FACTORY_DEFAULTS" == _arrArguments["application"]) {
	        _OnclickLanConfigChkBox();
	    }
	}
	
	function _InitEvent()
	{
		_oLanConfigChkBox.onclick = _OnclickLanConfigChkBox
		_oCancelBtn.onclick = _OnclickCancelBtn;
		_oOkBtn.onclick = _OnclickOkBtn;
	}
	
	function _OnclickLanConfigChkBox()
	{
		var bFlag = _oLanConfigChkBox.checked
		_oControlUnitIPV4TextBox.disabled = !bFlag;
		_oSubnetMaskTextBox.disabled = !bFlag;
		_oDefaultRouterIPV4TextBox.disabled = !bFlag;
	}
	
	function _OnclickCancelBtn()
	{
		window.returnValue = undefined;
		window.close();
		return false;
	}
	
	function _OnclickOkBtn()
	{
		var szPrompt;
		
		if ("LAN_CONFIG" == _arrArguments["application"] || _oLanConfigChkBox.checked)
		{
			if (!g_oCommonUse.IsNormalIP(_oControlUnitIPV4TextBox.value))
			{
				alert("Invalid Control Unit IP Address");
				return false;
			}
			
			if (!g_oCommonUse.IsNetMask(_oSubnetMaskTextBox.value))
			{
				alert("Invalid Subnet Mask");
				return false;
			}
			
			if (!g_oCommonUse.IsNormalIP(_oDefaultRouterIPV4TextBox.value))
			{
				alert("Invalid Default Router IP Address");
				return false;
			}
			
			// Lan configuration
			var arrLanCfg = new Array();
			arrLanCfg[_oLanCfg.GetManagmentIpAddrStr()]			= _oControlUnitIPV4TextBox.value;
			arrLanCfg[_oLanCfg.GetManagmentSubnetmaskStr()]		= _oSubnetMaskTextBox.value;
			arrLanCfg[_oLanCfg.GetManagmentDefgatewayStr()]		= _oDefaultRouterIPV4TextBox.value;
			_oLanCfg.SaveCfg(arrLanCfg);
		}
		
		// Usb action configuration
		var arrUsbActionCfg = new Array();
		if ("LAN_CONFIG" == _arrArguments["application"])
		{
			arrUsbActionCfg[_oUsbActionCfg.GetUsbIpNetworkSettingStr()] = "YES";
		}
		else if ("RESTORE_TO_FACTORY_DEFAULTS" == _arrArguments["application"])
		{
			arrUsbActionCfg[_oUsbActionCfg.GetUsbRestoreToFactoryDefaultsStr()] = "YES";
			if (!_oLanConfigChkBox.checked)
			{
				_oLanCfg.RemoveCfgFile();
			}
			else
			{
				arrUsbActionCfg[_oUsbActionCfg.GetUsbIpNetworkSettingStr()] = "YES";
			}
		}
		_oUsbActionCfg.SaveCfg(arrUsbActionCfg);
		
		alert("Configuration file updated successfully");
		
		window.returnValue = undefined;
		window.close();
		return false;
	}
	
	
}